<?php

/**
 * @file
 * Node Translation Access forms.
 */

/**
 * Deny access form for node.
 */
function node_translation_access_languages_form(&$form, &$form_state, $node) {
  $options = node_translation_access_get_language_list();
  $selected_languages = array();
  if (isset($node->nid)) {
    $selected_languages = db_query('SELECT language FROM node_translation_access WHERE nid=:nid', array(':nid' => $node->nid))->fetchAllKeyed(0, 0);
  }
  
  $form['translation_access'] = array(
    '#type' => 'fieldset',
    '#title' => t('Select languages to deny access'),
    '#weight' => 100,
    '#group' => 'additional_settings',
    '#tree' => TRUE,
  );
  $form['translation_access']['languages'] = array(
    '#type' => 'checkboxes',
    '#options' => $options,
    '#default_value' => $selected_languages,
  );
  return $form;
}

/**
 * Deny access form for menu item.
 */
function node_translation_access_menu_languages_form(&$form, &$form_state) {
  $options = node_translation_access_get_language_list();
  $denied = variable_get('node_translation_access_menu_items', array());
  $mlid = $form['mlid']['#value'];
  $selected_languages = array();
  if (isset($denied[$mlid])) {
    $selected_languages = $denied[$mlid];
  }

  $form['translation_access'] = array(
    '#type' => 'fieldset',
    '#title' => t('Select languages to deny access'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
    '#weight' => 100,
    '#tree' => TRUE,
  );
  $form['translation_access']['languages'] = array(
    '#type' => 'checkboxes',
    '#options' => $options,
    '#default_value' => $selected_languages,
  );
  $form['#submit'][] = 'node_translation_access_menu_languages_form_submit';

  return $form;
}

/**
 * Submit callback.
 */
function node_translation_access_menu_languages_form_submit($form, $form_state) {
  $mlid = $form['mlid']['#value'];
  if ($mlid) {
    $denied = variable_get('node_translation_access_menu_items', array());
    $denied[$mlid] = array();
    foreach ($form_state['values']['translation_access']['languages'] as $langcode => $state) {
      if ($state) {
        $denied[$mlid][$langcode] = $state;
      }
    }
    variable_set('node_translation_access_menu_items', $denied);
  }
}
